# NOTE: Derived from blib/lib/Puppet/VcsTools/File.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Puppet::VcsTools::File;

#line 478 "blib/lib/Puppet/VcsTools/File.pm (autosplit into blib/lib/auto/Puppet/VcsTools/File/archiveFile.al)"
sub archiveFile 
  {
    my $self = shift ;
    my %args = @_ ;

    my $infoRef = $args{info} || {};
    my $version = $args{revision} || $self->{myMode}{revision} ;
    my $auto = defined $args{auto} ? $args{auto} : 0 ;

    my $newRev = $self->prepareArchive(@_);
    return undef unless defined $newRev ;

    my $h = $self->createHistory() ;

    if ($auto)
      {
        $self->SUPER::archiveFile 
          (
           revision => $args{revision},
           'info' => $infoRef
          ) ;
      }
    else
      {
        my $top = $self->{body}->myDisplay() || $self->display();

        my $title = "Archiving $self->{name} from $version";
        # create a new multi slave for the archive
        my $f = $top->newSlave ('type' => 'MultiFrame', 'title' => $title);

        my $e = $f -> Entry (textvariable => \$newRev, width=> 6) 
          -> pack (qw/side right fill x expand 1/) ;

        $f -> Label (text => "in version: ") -> pack (side => 'right');

        my $cancelb;
        $f -> Button 
          (
           'text' => 'do archive...',
           'command' => sub 
           {
             $e->configure(state =>'disabled') ;
             $cancelb->configure(state =>'disabled') ;
             $self->{logEditor}->Show
               (
                name => $self->{name},
                revision => $newRev,
                info => $infoRef
               )
                 and 
                   $self->SUPER::archiveFile
                     (
                      revision=> $newRev, 
                      'info' => $infoRef,
                     ) ;
             $top->destroySlave($title);
           }
          ) -> pack (side => 'left' ) ;
        
        $f -> Button 
          (
           'text' => 'show diff',
           'command' => sub 
           {
             my $res = $self-> showDiff( rev1 => $version) ;
             $self->showResult($res) if defined $res;
           },
           'state' => defined $version ? 'normal' : 'disabled'
          ) -> pack (side => 'left' ) ;
        
        $cancelb = $f -> Button 
          (
           'text' => 'cancel',
           'command' => sub {$top->destroySlave($title) ; }
          ) -> pack (side => 'right' ) ;
        $f->waitWindow;
      }
  }

# internal
# end of Puppet::VcsTools::File::archiveFile
1;
