# NOTE: Derived from blib/lib/Puppet/VcsTools/File.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Puppet::VcsTools::File;

#line 346 "blib/lib/Puppet/VcsTools/File.pm (autosplit into blib/lib/auto/Puppet/VcsTools/File/display.al)"
sub display
  {
    my $self = shift ;
    my $top = $self->{body}->display
      (
       onDestroy => sub 
       {
         #print "cleaning up Tk private hash\n";
         print "Whoa there Tk private hash is not defined\n" unless
           defined $self->{tk} ;
         delete $self->{tk};
       },
       @_
      );

    return unless defined $top;
    require Tk::Multi::Frame;
    require Tk::Multi::Text;

    # must add a open history command
    
    # must add menu button related to the graph funcionnality
    # i.e draw, merge, show diff
    # these function will ask for currently selected nodes
    $top->Subwidget('fileMenu')->command
      (
       -label => 'check', 
       command => sub {$self->check ;}
      ) ;

    $self->{tk}{openHistButton} = 
      $top->Subwidget('fileMenu')->command
        (
         -label => 'open history...', 
         state=> 'disabled',
         command => sub {$self->openHistory;}
        ) ;
    
    $self->{tk}{createArchiveButton} = 
      $top->Subwidget('fileMenu')->command
        (
         -label => 'create archive',
         -state => 'disabled',
         command => sub 
         {
           $self->SUPER::archiveFile();
           $self->updateButtonCfg();
         }
        ) ;

    $self->{tk}{archiveButton} = 
      $top->Subwidget('fileMenu')->command
        (
         -label => 'archive...',
         -state => 'disabled',
         command => sub {$self->archiveFile();}
        ) ;

    $self->{tk}{editButton} = 
       $top->Subwidget('fileMenu')->command
        (
         -label => 'edit',
         -state => 'disabled',
         command => sub {$self->edit();}
        ) ;

    $top->newSlave
      (
       'type' => 'MultiText', 
       'title' => 'informations',
       side => 'top',
       'hidden' => 0 
      );

    my $f = $top->newSlave
      (
       'type' => 'MultiFrame', 
       'title' => 'file',
       side => 'top'
      );

    require Tk::Checkbutton;
    $f -> Label (text => "File: $self->{name} ") ->  pack(qw/side left/) ;   
    $f -> Label (textvariable => \$self->{status}{source})->pack(qw/side left/) ;
    $f -> Label (text => " ") ->  pack(qw/side left/) ;   
    $f -> Label (textvariable => \$self->{status}{archive})
      ->pack(qw/side left/);

    $self->{tk}{lockButton} = 
      $f -> Checkbutton
        (
         text => 'locked', 
         variable => \$self->{myMode}{locked},
         state => 'disabled',
         command => sub
         {
           my $r = $self->changeLock( lock => $self->{myMode}{locked});
           $self->{myMode}{locked} = 1-  $self->{myMode}{locked} unless 
             defined $r ;
         }
        )
        -> pack(qw/side right/) ;      

    $self->{tk}{writeButton} = 
      $f -> Checkbutton
        (
         text => 'writable', 
         variable => \$self->{myMode}{writable},
         state => 'disabled',
         command => sub
         {
           my $r = $self->chmodFile(writable => $self->{myMode}{writable});
           $self->{myMode}{writable} = 1-$self->{myMode}{writable} unless 
             defined $r ;
         }
        )
        -> pack(qw/side right/) ;      

    $f -> Label (textvariable => \$self->{myMode}{'revision'}) 
      ->  pack(qw/side right/) ;   
    $f -> Label (text => ' revision: ') ->  pack(qw/side right/) ;   
    #added by Bob
    return $top;
  }

# open correct window
# user select archive
# File set up default info array,
# File run editor on default array
# user select archive button
# File checks-in the file and asks history to create new version.

# end of Puppet::VcsTools::File::display
1;
