# NOTE: Derived from blib/lib/Puppet/VcsTools/File.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Puppet::VcsTools::File;

#line 608 "blib/lib/Puppet/VcsTools/File.pm (autosplit into blib/lib/auto/Puppet/VcsTools/File/openHistory.al)"
sub openHistory
  {
    my $self = shift ;

    my $h = $self->createHistory() ;
    # create or raise the display, and then get the display ref
    my $htop =  $h->display  || $h->body()->myDisplay(); 
    
    my $tree = $h->getTreeGraph() ;

    $tree -> command
      (
       on => 'menu',
       label => 'merge', 
       command => sub 
       {
         my @revs = $tree->getSelectedNodes();
         if (defined @revs and scalar(@revs) == 2) 
           {
             $self->merge ( rev1 => $revs[0], rev2 => $revs[1]);
           }
         else {print scalar(@revs)," nodes selected\n";}
       }
      );
    
    $tree -> command
      (
       on => 'menu',
       -label => 'reload from archive', 
       command => sub 
       {
         $self->updateHistory();
       }
      );
    
    $tree -> command
      (
       on => 'menu',
       -label => 'show diff', 
       command => sub 
       {
         my @revs = $tree->getSelectedNodes();
         if (defined @revs and scalar(@revs) == 2)
           {
             my $res = $self->showDiff
               ( 
                rev1 => $revs[0],
                rev2 => $revs[1],
               );
             $h->showResult($res);
           }
         else
           {
             print scalar(@revs)," nodes selected\n";
           }
       }
      );
    
    my $showDiff = sub 
      {
        my %args = @_ ;
        my $ref = $self->showDiff (rev1 => $args{from} , rev2 => $args{to});
        $h->showResult($ref) ;
      } ;

    $tree->arrowBind
      (
       button => '<2>',
       color => 'yellow',
       command => $showDiff
      );
    
    $tree->command
      (
       on => 'arrow',
       label => 'show diff',
       command => $showDiff
      ) ;


    # bind button <2> on nodes to show content
    $tree->command
      ( 
       on => 'node',
       label => 'show content',
       command => sub 
       {
         my %args = @_ ;
         my $ref = $self->getContent(revision => $args{nodeId}) ;
         $h->showResult($ref) ;
       }
      ) ;

    $tree->command
      ( 
       on => 'node',
       label => 'check-out',
       command => sub 
       {
         my %args = @_ ;
         my $ref = $self->checkOut(revision => $args{nodeId},lock => 0) ;
         $h->showResult($ref) ;
       }
      ) ;

    my $editLog = sub
      {
         my  %args = @_ ;
         my $rev = $args{to} || $args{nodeId} ;
         $self->checkArchive() ;
         my $iref = $h->getInfo($rev) ;
         my $res = $self->{logEditor}->Show
           (
            name => $self->{name},
            revision => $rev,
            info => $iref
           );
         
         if ($res)
           {
             # archive Log
             $self->archiveLog
               (
                revision => $rev,
                info => $iref
               );
           }
      };

    $tree->command 
      (
       on => 'arrow', 
       label =>'edit log',
       command => $editLog
      ) if defined $self->{logEditor};

    $tree->command
      (
       on => 'node',
       label =>'edit log',
       command => $editLog
      ) if defined $self->{logEditor} ;

  }

# end history part

## Handling the real file part

# end of Puppet::VcsTools::File::openHistory
1;
